<template src="./template.html"></template>
<script lang="ts">
// import { getModule } from "nuxt-property-decorator";
function sleep(milliseconds: number) {
  return new Promise((resolve, reject) => {
    setTimeout(() => {
      resolve(true);
    }, milliseconds);
  });
}
import { forEach } from "lodash";
import { Vue, Component, Prop } from "vue-property-decorator";
import { api, api_key_tiny_editor, regexEmail } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { Watch } from "nuxt-property-decorator";
// import axios from "axios";
// import UserModule from "~/store/user";
// import { Store } from "vuex";
@Component({
  components: {},
})
export default class SettingSellerReViewStoreComponent extends Vue {
  @Prop()
  productId!: string;

  tab = 0;
  rating = 4.5;
  selected = [2];
  reviewDetail = false;

  listImgReview = [];
  listImageRender = [];
  listReview: any = [];
  listReviewCreate: any = [];

  avg = 0;
  idxEdit = 0;
  reviewId = "";

  review: any = {};

  onGetAvg() {
    let total = 0;
    if (this.listReview.length) {
      this.listReview.forEach((item: any) => {
        total += item.rating;
      });
      this.avg = Math.round(total / this.listReview.length);
    } else {
      this.listReviewCreate.forEach((item: any) => {
        total += item.rating;
      });
      this.avg = Math.round(total / this.listReviewCreate.length);
    }
  }
  loadingTable = false;
  loading = false;
  loadingId = "";
  dialogEdit = false;

  async onGetReview() {
    try {
      this.loadingTable = true;
      const res = await this.$api.review.AdminGet(this.productId);
      if (res?.data) {
        this.listReview = res?.data;
        await sleep(500);
        this.onGetAvg();
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  openDialogEdit(review: any, idx: number) {
    this.review = review;
    this.listImageRender = review.images;
    this.idxEdit = idx;
    this.dialogEdit = true;
  }

  async onDeleteReview(id: string, idx: number) {
    try {
      if (
        this.productId &&
        !this.$route.path.includes("/admin/products/duplicate")
      ) {
        const reviewId = id;
        this.loadingId = id;
        await this.$api.review.AdminDelete(this.productId, reviewId);
        this.onGetReview();
      } else {
        this.listReview.splice(idx, 1);
        this.listReviewCreate.splice(idx, 1);
      }
      this.$pushNotification.success("Delete review success");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingId = "";
    }
  }
  convertImage(url: string) {
    if (url.includes("data:image")) return url;
    return `${api}/${url}`;
  }

  onUploadImage() {
    //@ts-ignore
    this.$refs.fileImage.$refs.input.click();
  }
  onChangeImage(e: any) {
    this.listImgReview = [];
    this.listImageRender = [];
    for (let item of e) {
      if (!item.type.includes("image/")) {
        continue;
      }
    }
    this.listImgReview = e;
    for (let item of e) {
      this.createImage(item);
    }
    // if (e.length > 0 && e.length < 4) {
    //   this.listImgReview = [];
    //   this.listImageRender = [];
    //   for (let item of e) {
    //     if (!item.type.includes("image/")) {
    //       continue;
    //     }
    //   }
    //   this.listImgReview = e;
    //   for (let item of e) {
    //     this.createImage(item);
    //   }
    // } else {
    //   this.$pushNotification.error("Can only add maximum 3 images");
    // }
  }

  createImage(e: any) {
    const reader = new FileReader();
    reader.onload = (e) => {
      //@ts-ignore
      this.listImageRender.push(e.target.result);
    };
    reader.readAsDataURL(e);
  }

  removeImg(idx: number) {
    this.listImageRender.splice(idx, 1);
  }

  form = {
    email: "",
    name: "",
    phoneNumber: "",
    rating: 5,
    content: "",
    title: "",
  };
  imageSrc = "";

  async onPostReview() {
    try {
      if (!regexEmail.test(this.form.email)) {
        return this.$pushNotification.error("Email invalid");
      }
      if (
        !this.form.email ||
        !this.form.name ||
        !this.form.rating ||
        !this.form.content ||
        !this.form.title
      ) {
        return this.$pushNotification.error("Please fill all field");
      }
      const formData = new FormData();
      formData.append("email", this.form.email);
      formData.append("name", this.form.name);
      // @ts-ignore
      formData.append("rating", this.form.rating);
      formData.append("content", this.form.content);
      formData.append("title", this.form.title);
      // @ts-ignore
      if (this.listImgReview.length) {
        for (let img of this.listImgReview) {
          formData.append("images", img);
        }
      }
      this.listReview.push({ ...this.form, images: this.listImageRender });
      this.listReviewCreate.push(formData);
      if (this.productId) {
        this.onCreateView();
      }
      this.reviewDetail = false;
      this.$pushNotification.success("Add review successfully");
      this.form = {
        email: "",
        name: "",
        phoneNumber: "",
        rating: 0,
        content: "",
        title: "",
      };
      this.listImageRender = [];
      this.onGetAvg();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onEditReview() {
    if (!regexEmail.test(this.review.email)) {
      return this.$pushNotification.error("Email invalid");
    }
    if (
      !this.review.email ||
      !this.review.name ||
      !this.review.rating ||
      !this.review.content ||
      !this.review.title
    ) {
      return this.$pushNotification.error("Please fill all field");
    }
    try {
      const formData = new FormData();
      formData.append("email", this.review.email);
      formData.append("name", this.review.name);
      // @ts-ignore
      formData.append("rating", this.review.rating);
      formData.append("content", this.review.content);
      formData.append("title", this.review.title);
      // @ts-ignore
      if (this.listImgReview.length) {
        for (let img of this.listImgReview) {
          formData.append("images", img);
        }
      } else {
        for (let img of this.listImageRender) {
          formData.append("images", img);
        }
      }

      if (this.productId && this.review._id) {
        this.onUpdateReview(formData);
      }
      this.onGetAvg();
      this.$pushNotification.success("Update review successfully");
      this.dialogEdit = false;
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onUpdateReview(formData: FormData) {
    try {
      this.loading = true;
      await this.$api.product.updateReview(
        this.productId,
        this.review._id,
        formData
      );
      this.onGetReview();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onCreateView() {
    try {
      this.loading = true;
      const proms = [];
      for (let file of this.listReviewCreate) {
        proms.push(this.$api.review.AdminPost(this.productId, file));
      }
      await Promise.all(proms);
      if (this.$route.path.includes("/admin/products/edit")) {
        this.onGetReview();
      }
      if (!this.$route.path.includes("/admin/products/duplicate")) {
        this.listReview = [];
        this.listReviewCreate = [];
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  @Watch("productId")
  changedProductId(val: string) {
    if (val && this.$route.path.includes("/admin/products/edit")) {
      // this.onGetReview();
      this.onGetAvg();
    }
    this.onCreateView();
    // this.onPostReview();
  }

  @Watch("reviewDetail")
  changedReviewDialog(value: boolean) {
    this.listImageRender = [];
    this.listImgReview = [];
  }
}
</script>
<style lang="scss" scoped>
.image-cmt {
  min-width: 55px;
  max-width: 56px;
  width: 100%;
  height: 56px;
}
</style>
